HDU 1331 Function Run Fun(记忆化搜索)
Function Run Fun
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 1387 Accepted Submission(s): 709
Problem Description
We all love recursion! Don't we?
Consider a three-parameter recursive function w(a, b, c):
if a <= 0 or b <= 0 or c <= 0, then w(a, b, c) returns:
1
if a > 20 or b > 20 or c > 20, then w(a, b, c) returns:
w(20, 20, 20)
if a < b and b < c, then w(a, b, c) returns:
w(a, b, c-1) + w(a, b-1, c-1) - w(a, b-1, c)
otherwise it returns:
w(a-1, b, c) + w(a-1, b-1, c) + w(a-1, b, c-1) - w(a-1, b-1, c-1)
This is an easy function to implement. The problem is, if implemented directly, for moderate values of a, b and c (for example, a = 15, b = 15, c = 15), the program takes hours to run because of the massive recursion.
Consider a three-parameter recursive function w(a, b, c):
if a <= 0 or b <= 0 or c <= 0, then w(a, b, c) returns:
1
if a > 20 or b > 20 or c > 20, then w(a, b, c) returns:
w(20, 20, 20)
if a < b and b < c, then w(a, b, c) returns:
w(a, b, c-1) + w(a, b-1, c-1) - w(a, b-1, c)
otherwise it returns:
w(a-1, b, c) + w(a-1, b-1, c) + w(a-1, b, c-1) - w(a-1, b-1, c-1)
This is an easy function to implement. The problem is, if implemented directly, for moderate values of a, b and c (for example, a = 15, b = 15, c = 15), the program takes hours to run because of the massive recursion.
Input
The input for your program will be a series of integer triples, one per line, until the end-of-file flag of -1 -1 -1. Using the above technique, you are to calculate w(a, b, c) efficiently and print the result.
Output
Print the value for w(a,b,c) for each triple.
Sample Input
1 1 1
2 2 2
10 4 6
50 50 50
-1 7 18
-1 -1 -1
Sample Output
w(1, 1, 1) = 2
w(2, 2, 2) = 4
w(10, 4, 6) = 523
w(50, 50, 50) = 1048576
w(-1, 7, 18) = 1
Source
Recommend
Ignatius.L
题意:给你一些递归条件,然后告诉你a,b,c的值,要求算出调用w(a,b,c)函数后所返回的值。
分析:一道典型的自底向上的记忆化搜索问题。经典地道的DP动态规划问题。如果直接用递归做肯定会超时,因为它的子问题实在是太多了,递归过程有许多重复计算的部分,解决办法就是用记忆化搜索解决,自底向上的递推,将已求解出来的结果存到数组里保存下来,下次再递归到此处直接读取答案就行,避免重复计算。复杂度O(n^3)。
分析:一道典型的自底向上的记忆化搜索问题。经典地道的DP动态规划问题。如果直接用递归做肯定会超时,因为它的子问题实在是太多了,递归过程有许多重复计算的部分,解决办法就是用记忆化搜索解决,自底向上的递推,将已求解出来的结果存到数组里保存下来,下次再递归到此处直接读取答案就行,避免重复计算。复杂度O(n^3)。
#include<iostream> using namespace std; int x[25][25][25]={0}; int w(int a,int b,int c) { if(a<=0||b<=0||c<=0) return 1; if(x[a][b][c]!=0));//关键语句,避免重复计算 return x[a][b][c]; if(a<b&&b<c) { x[a][b][c]=w(a,b,c-1)+w(a,b-1,c-1)-w(a,b-1,c); return x[a][b][c]; } else { x[a][b][c]=w(a-1,b,c)+w(a-1,b-1,c)+w(a-1,b,c-1)-w(a-1,b-1,c-1); return x[a][b][c]; } } int main() { int a,b,c; while(~scanf("%d %d %d",&a,&b,&c)) { if(a==-1&&b==-1&&c==-1) break; if(a<=0||b<=0||c<=0) { printf("w(%d, %d, %d) = %d\n",a,b,c,1); continue; } if(a>20||b>20||c>20) printf("w(%d, %d, %d) = %d\n",a,b,c,w(20,20,20)); else printf("w(%d, %d, %d) = %d\n",a,b,c,w(a,b,c)); } return 0; }